---

- name: create solr.in.sh
  template:
    src: solr.in.sh.j2
    dest: /etc/default/solr.in.sh
    owner: root
    group: root
    mode: 0755
  notify: restart solr

- name: detect if solr.xml exists
  stat:
    path: "{{ solr_home_directory }}/solr.xml"
  register: solr_xml_stats

# copy solr.xml in place
- name: copy solr.xml into place
  copy:
    remote_src: true
    src: /opt/solr-{{ solr_version }}/server/solr/solr.xml
    dest: "{{ solr_home_directory }}/"
    owner: "{{ solr_user }}"
    group: "{{ solr_group }}"
  when: not solr_xml_stats.stat.exists

# check if CoreMedia specify stuff is in place
- name: Ensure solr.xml contains coreRootDirectory
  lineinfile:
    path: "{{ solr_home_directory }}/solr.xml"
    regexp: '(.*)coreRootDirectory(.*)'
    state: absent
  check_mode: true
  changed_when: false
  register: presence

- name: replacing a line in file
  lineinfile:
    path: "{{ solr_home_directory }}/solr.xml"
    regexp: 'maxBooleanClauses'
    line: ''

- name: insert CoreMedia specifc parts
  blockinfile:
    path: "{{ solr_home_directory }}/solr.xml"
    marker: "<!-- {mark} ANSIBLE MANAGED BLOCK -->"
    insertafter: '<solr>'
    block: |2
          <str name="sharedLib">lib</str>
          <bool name="shareSchema">true</bool>
          <str name="coreRootDirectory">${coreRootDirectory:cores}</str>
  when: not presence.found

- name: fix permissions for application home directory  # noqa 301
  command: "{{ item }}"
  args:
    warn: false
  with_items:
    - chown -R {{ solr_user }}:{{ solr_group }} {{ solr_home_directory }}
    - chown -R {{ solr_user }}:{{ solr_group }} /opt/solr-{{ solr_version }}
    - find /opt/solr-{{ solr_version }} -maxdepth 5 -type d ! -perm 0750 -exec chmod 0750 {} \;
    - find /opt/solr-{{ solr_version }} -maxdepth 5 -type f ! -perm 0640 -exec chmod 0640 {} \;
    - find /opt/solr-{{ solr_version }} -maxdepth 5 -type f -name "solr" ! -perm 0750 -exec chmod 0750 {} \;
    - find {{ solr_home_directory }} -maxdepth 5 -type d ! -perm 0750 -exec chmod 0750 {} \;
    - find {{ solr_home_directory }} -maxdepth 5 -type f ! -perm 0640 -exec chmod 0640 {} \;
  no_log: true
